package com.liangjian.web.common.config;

import com.liangjian.web.common.interceptor.DynamicParamAnalyser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

/**
 * Created by huangziqi on 2019/12/17
 *
 * 用于解析Get请求时携带的参数，动态查询
 */
@Configuration
public class DynamicParamConfig implements WebMvcConfigurer {

    @Autowired
    private DynamicParamAnalyser analyser;

    @Override
    public void addInterceptors(InterceptorRegistry registry) {
        registry.addInterceptor(analyser);
    }

    @Bean
    @ConditionalOnMissingBean(DynamicParamAnalyser.class)
    public DynamicParamAnalyser dynamicParamAnalyser() {
        return new DynamicParamAnalyser();
    }
}
