package com.liangjian.web.common.config;

import com.liangjian.web.common.controller.RestfulCrudController;
import com.liangjian.web.common.service.crud.NameServiceMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * Created by huangziqi on 2020/1/13
 */
@Configuration
public class RestfulCrudConfig {

    @Autowired
    private NameServiceMapper nameServiceMapper;

    @Bean
    @ConditionalOnMissingBean(NameServiceMapper.class)
    public NameServiceMapper nameServiceMapper() {
        return new NameServiceMapper();
    }

    @Bean
    @ConditionalOnMissingBean(RestfulCrudController.class)
    public RestfulCrudController restfulCrudController() {
        return new RestfulCrudController(nameServiceMapper);
    }
}
