package com.liangjian.web.common.dynamic;

import com.liangjian.web.common.entity.helper.EntityHelper;

import java.util.Date;

/**
 * Created by huangziqi on 2019/12/17
 */
@SuppressWarnings("unchecked")
public class DynamicFilter {
    protected String field;
    protected OperateType operate;
    protected String value;

    public <A> A transportType(Class<A> clazz) {
        if(clazz.equals(Integer.class)) {
            return (A) Integer.valueOf(value);
        } else if(clazz.equals(Long.class)) {
            return (A) Long.valueOf(value);
        } else if(clazz.equals(Double.class)) {
            return (A) Double.valueOf(value);
        } else if(clazz.equals(Float.class)) {
            return (A) Float.valueOf(value);
        } else if(clazz.equals(Date.class)) {
            return (A) new Date(value);
        } else if(clazz.equals(Boolean.class)) {
            return (A) Boolean.valueOf(value);
        } else if(clazz.equals(String.class)) {
            return (A) value;
        } else {
            throw new RuntimeException("unknown supported filter type yet: " + clazz.getName());
        }
    }

    public Object getValueBindType(EntityHelper helper) {
        var opt = helper.getFieldClass(field);
        if (opt.isEmpty()) {
            throw new RuntimeException("entity helper get type null");
        } else {
            return transportType(opt.get());
        }
    }

    public String getField() {
        return field;
    }

    public void setField(String field) {
        this.field = field;
    }

    public OperateType getOperate() {
        return operate;
    }

    public void setOperate(OperateType operate) {
        this.operate = operate;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }
}
