package com.liangjian.web.common.entity.helper;

import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springframework.data.domain.Page;

import java.util.List;

/**
 * Created by huangziqi on 2020/1/13
 */
public class PageWrapper<T> {
    private List<T> content;
    private Long totalElement;
    private Long totalPage;
    private Long currentPage;

    public PageWrapper(List<T> content, Long totalElement, Long totalPage, Long currentPage) {
        this.content = content;
        this.totalElement = totalElement;
        this.totalPage = totalPage;
        this.currentPage = currentPage;
    }

    public static <T> PageWrapper<T> wrap(IPage<T> page) {
        return new PageWrapper<>(page.getRecords(), page.getTotal(), page.getPages(), page.getCurrent());
    }

    public static <T> PageWrapper<T> wrap(Page<T> page) {
        return new PageWrapper<>(page.getContent(), page.getTotalElements(), (long)page.getTotalPages(), (long)page.getPageable().getPageNumber());
    }

    public List<T> getContent() {
        return content;
    }

    public void setContent(List<T> content) {
        this.content = content;
    }

    public Long getTotalElement() {
        return totalElement;
    }

    public void setTotalElement(Long totalElement) {
        this.totalElement = totalElement;
    }

    public Long getTotalPage() {
        return totalPage;
    }

    public void setTotalPage(Long totalPage) {
        this.totalPage = totalPage;
    }

    public Long getCurrentPage() {
        return currentPage;
    }

    public void setCurrentPage(Long currentPage) {
        this.currentPage = currentPage;
    }
}
