package com.liangjian.web.common.service.crud;

import com.liangjian.web.common.dynamic.DynamicParams;
import com.liangjian.web.common.entity.helper.EntityHelper;
import com.liangjian.web.common.entity.helper.PageWrapper;

import java.io.Serializable;
import java.util.List;
import java.util.Optional;

/**
 * Created by huangziqi on 2020/1/13
 */
public interface DynamicApiService<T> {

    /**
     * 获取用于解析、处理、转换用的实例帮助器
     * @return
     */
    EntityHelper getEntityHelper();

    /**
     * 获取Service映射名称
     * @return
     */
    String getMappedName();

    /**
     * 通过动态条件分页查询
     * @param params
     * @return
     */
    PageWrapper<T> getPageByCondition(DynamicParams params);

    /**
     * 通过动态条件查询列表
     * @param params
     * @return
     */
    List<T> getListByCondition(DynamicParams params);

    /**
     * 通过id查询单个实例
     * @param id
     * @return
     */
    Optional<T> findById(Serializable id);

    /**
     * 新增模型
     * @param json
     * @return
     */
    boolean addModel(String json);

    /**
     * 更新模型
     * @param json
     * @return
     */
    boolean updateModel(String json);

    /**
     * 删除模型
     * @param json
     * @return
     */
    boolean deleteModel(String json);

    /**
     * 通过Id删除模型
     * @param id
     * @return
     */
    boolean deleteModelById(Serializable id);
}
