package com.liangjian.web.common.service.crud;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;

/**
 * Created by huangziqi on 2019/12/26
 */
@Service
public class NameServiceMapper {
    private Logger logger = LoggerFactory.getLogger(NameServiceMapper.class);

    @Autowired(required = false)
    List<DynamicApiService> namedServices;

    public Optional<DynamicApiService> getDynamicApiService(String modelName) {
        if(namedServices == null) {
            throw new RuntimeException("namedServices can't be injected.");
        }
        for (DynamicApiService namedService : namedServices) {
            if(namedService.getMappedName().equals(modelName)) {
                return Optional.of(namedService);
            }
        }
        logger.error("can't not find suitable service for : " + modelName);
        return Optional.empty();
    }
}
